' HC2_DP_TX1C.bas for SN 101545
' 2022/10/01
' uses: ^, I, K, N

I2cD[31]=$3C
Gosub _InitOled
Gosub _ContrastMax
Gosub _SetMyChars

Do
	Recv 2000
	Lclr
	Gosub _ClearOled
	If Stat=10 Then
		Lprint Rxd
		Lpos=64:Lprint "rssi";Rssi
		If Rxd[7]>10 Then
			I=0:N=0:^="":A=$20:B=$20
			For I=0 To Rxd[7]-1
				If Rxd[I+8]=$3A Then
					N=N+1
					If N=1 Then
						^=^;Chr($F2);"C ":Gosub _DrawText
					ElseIf N=2 Then
						^=^;"% ":Gosub _DrawText
					ElseIf N=3 Then
						^=^;Chr($F2);"CDP ":Gosub _DrawText2
					ElseIf N=4 Then
						I2cD(0)=^[0]:Gosub _DrawChar
					EndIf
					^=""
				Else
					^=^;Chr(Rxd[I+8])
				EndIf
			Next
			I2cD(0)=^[0]:Gosub _DrawChar
		Else
			^="HC2":Gosub _DrawText1
			^="no response":Gosub _DrawText2
		EndIf
		^=Rssi
		I2cD[1]=12:I2cD[2]=1:Gosub _SetCur
		Gosub _DrawText
		
		I2cD[1]=13:I2cD[2]=0:Gosub _SetCur
		If Rssi>-70 Then I2cD[1]=5
		ElseIf Rssi>-85 Then I2cD[1]=4
		ElseIf Rssi>-100 Then I2cD[1]=3
		ElseIf Rssi>-115 Then I2cD[1]=2
		ElseIf Rssi>-130 Then I2cD[1]=1
		Else I2cD[1]=0 EndIf
		Gosub _DrawAntLevel
	Else
		Lpos=64:Lprint "error ";Stat
		I2cD[1]=14:I2cD[2]=0:Gosub _SetCur
		I2cD[1]=0:Gosub _DrawAntLevel
	EndIf
	Send "OK"
	Delay 500
Loop
End

_SetCur
	I2cD[0]=$80+I2cD[2]*$20+I2cD[1]
	I2cW I2cD[31],$0,1:Delay 10
Return

_DrawChar
	I2cW I2cD[31],$40,1:Delay 1
Return

_DrawText
	K=0
	While ^[K]>0
		I2cD[0]=^[K]
		I2cW I2cD[31],$40,1:Delay 1
		K=K+1
	Loop
Return

_DrawText1
	I2cD[0]=$80
	I2cW I2cD[31],$0,1:Delay 1
	K=0
	While ^[K]>0
		I2cD[0]=^[K]
		I2cW I2cD[31],$40,1:Delay 1
		K=K+1
	Loop
Return

_DrawText2
	I2cD[0]=$80+$20
	I2cW I2cD[31],$0,1:Delay 1
	K=0
	While ^[K]>0
		I2cD[0]=^[K]
		I2cW I2cD[31],$40,1:Delay 1
		K=K+1
	Loop
Return

_ClearOled
	I2cD[0]=$1
	I2cW I2cD[31],$0,1:Delay 10
Return

_InitOled
	I2cD[0]=$1
	I2cW I2cD[31],$0,1:Delay 10
	I2cD[0]=$2
	I2cW I2cD[31],$0,1:Delay 10
	I2cD[0]=$C
	I2cW I2cD[31],$0,1:Delay 10
	I2cD[0]=$1
	I2cW I2cD[31],$0,1:Delay 10
Return

_ContrastMax
	I2cD[0]=$2A
	I2cW I2cD[31],$0,1:Delay 10
	I2cD[0]=$79
	I2cW I2cD[31],$0,1:Delay 10
	I2cD[0]=$81
	I2cW I2cD[31],$0,1:Delay 10
	I2cD[0]=$FF
	I2cW I2cD[31],$0,1:Delay 10
	I2cD[0]=$78
	I2cW I2cD[31],$0,1:Delay 10
	I2cD[0]=$28
	I2cW I2cD[31],$0,1:Delay 10
Return

_DrawAntLevel
	If I2cD[1]=0 Then
		I2cD[0]=0:Gosub _DrawChar
	ElseIf I2cD[1]=1 Then
		I2cD[0]=1:Gosub _DrawChar
	ElseIf I2cD[1]>=2 Then
		I2cD[0]=2:Gosub _DrawChar
		If I2cD[1]=3 Then
			I2cD[0]=3:Gosub _DrawChar
		ElseIf I2cD[1]>=4 Then
			I2cD[0]=4:Gosub _DrawChar
			If I2cD[1]>=5 Then
				I2cD[0]=5:Gosub _DrawChar
			EndIf
		EndIf
	EndIf
Return

_SetMyChars
	I2cD[0]=$40|0*$8
	I2cW I2cD[31],$0,1:Delay 1
	I2cD[0]=$1C
	I2cD[1]=$8
	I2cD[2]=$8
	I2cD[3]=$0
	I2cD[4]=$0
	I2cD[5]=$0
	I2cD[6]=$0
	I2cD[7]=$0
	I2cW I2cD[31],$40,8:Delay 1
	
	I2cD[0]=$40|1*$8
	I2cW I2cD[31],$0,1:Delay 1
	I2cD[0]=$1C
	I2cD[1]=$8
	I2cD[2]=$8
	I2cD[3]=$0
	I2cD[4]=$0
	I2cD[5]=$C
	I2cD[6]=$C
	I2cD[7]=$0
	I2cW I2cD[31],$40,8:Delay 1
	
	I2cD[0]=$40|2*$8
	I2cW I2cD[31],$0,1:Delay 1
	I2cD[0]=$1C
	I2cD[1]=$8
	I2cD[2]=$8
	I2cD[3]=$0
	I2cD[4]=$3
	I2cD[5]=$1B
	I2cD[6]=$1B
	I2cD[7]=$0
	I2cW I2cD[31],$40,8:Delay 1
	
	I2cD[0]=$40|3*$8
	I2cW I2cD[31],$0,1:Delay 1
	I2cD[0]=$0
	I2cD[1]=$0
	I2cD[2]=$0
	I2cD[3]=$18
	I2cD[4]=$18
	I2cD[5]=$18
	I2cD[6]=$18
	I2cD[7]=$0
	I2cW I2cD[31],$40,8:Delay 1
	
	I2cD[0]=$40|4*$8
	I2cW I2cD[31],$0,1:Delay 1
	I2cD[0]=$0
	I2cD[1]=$0
	I2cD[2]=$3
	I2cD[3]=$1B
	I2cD[4]=$1B
	I2cD[5]=$1B
	I2cD[6]=$1B
	I2cD[7]=$0
	I2cW I2cD[31],$40,8:Delay 1
	
	I2cD[0]=$40|5*$8
	I2cW I2cD[31],$0,1:Delay 1
	I2cD[0]=$0
	I2cD[1]=$18
	I2cD[2]=$18
	I2cD[3]=$18
	I2cD[4]=$18
	I2cD[5]=$18
	I2cD[6]=$18
	I2cD[7]=$0
	I2cW I2cD[31],$40,8:Delay 1
Return