' HC2_DP_TX1C.bas for SN:LRA-101546
' 2022/10/01
' uses  ^, A, B, C, H, I, J, K, M, N, T, U, V, W, X, Y

I2cD[31] = $3C ' OLED_I2c_ADRS
Gosub _InitOled
Gosub _ContrastMax
Gosub _SetMyChars

ALoad
UBaud = 19200
While Uinkey >= 0: Loop
Do
	m = 0: T = 0: H = 0: A = $20: B = $20
	UPrint "{ 99RDD}"
	Delay 100
	F = 0
	While 1
		c = UInkey
		If c > 0 Then
			F = F + 1
			If c = 59 Then m = m + 1: n = 2 EndIf
			If m = 5 Then
				If (c = 46) && (n = 1) Then 
					T = T/10:n = 0 
				ElseIf (c >= 48) && (c <= 57) && n >= 0 Then
					T = T + (c - 48) * Pow(10, n): n = n - 1
				EndIf
			ElseIf m = 1 Then
				If (c = 46) && (n = 1) Then 
					H = H/10:n = 0
				ElseIf (c >= 48) &&(c <= 57) && n >= 0 Then
					H = H + (c - 48) * Pow(10, n): n = n - 1
				EndIf
			ElseIf (m = 4) && (B = $20) && (c <> 59) Then B = c
			ElseIf (m = 8) && (A = $20) && (c <> 59) Then A = c
			EndIf
		Else Exit
		EndIf
	Loop
	'' Calc DewPoint	
	'' _ȉ2܂ł̐ɂ
	U = T * 10 + 800 ' -8
	V = H * 10 - 1000 ' 10%RH 
	W = 990 ''I_x
	X = U % 200 '2
	Y = V % 1000 '10%RH 
	i = U / 200 'f[^ʒu Row
	j = V / 1000'f[^ʒu Col
	
	If (i < 24) && (j < 9) Then
		''  4 _̘I_x
		@[250] = @[i * 10 + j]
		@[251] = @[i * 10 + j + 1]
		@[252] = @[(i + 1) * 10 + j]
		@[253] = @[(i + 1) * 10 + j + 1]
		'' z
		@[254] = Abs(@[252] - @[250]) * X / 200 + @[250]
		@[255] = Abs(@[253] - @[251]) * X / 200 + @[251]
		'' I_x * 10
		W = (Abs(@[255] - @[254]) * Y / 1000 + @[254]) / 10
	EndIf

	
	LClr
	LPrint T/10; "."; T % 10; " ";H / 10;"%"
	LPos = 64
	LPrint "DP ";W/10;".";W % 10
	
	If F > 45 Then
		Send T / 10; "."; T % 10; ":"; H / 10; ".";H % 10; ":";W / 10;".";W % 10;":";Chr(A);":";Chr(B)
	Else
		Send "  "
	EndIf
	Recv 1000
	
	Gosub _ClearOled
	If F > 45 Then
		^ = T / 10; "." T % 10; Chr($F2);"C ": Gosub _DrawText1
		^ = H / 10; "." H % 10; "% ": Gosub _DrawText
		^ = W / 10; ".";W % 10; Chr($F2);"CDP ": Gosub _DrawText2
		I2cD(0)= A:Gosub _DrawChar
		I2cD(0)= B:Gosub _DrawChar
	Else
		^ = "HC2"
		I2cD[1]=0:I2cD[2]=0:Gosub _SetCur
		Gosub _DrawText1	
		^ = "no response"
		Gosub _DrawText2	
	EndIf

	if Stat = 10 Then
		^ = Rssi
		I2cD[1]=12:I2cD[2]=1:Gosub _SetCur:	Gosub _DrawText
		
		I2cD[1]=13:I2cD[2]=0:Gosub _SetCur
		If Rssi = 0 Then I2cD[1] = 0
		ElseIf Rssi > -70  Then I2cD[1] = 5
		ElseIf Rssi > -85  Then I2cD[1] = 4
		ElseIf Rssi > -100 Then I2cD[1] = 3
		ElseIf Rssi > -115 Then I2cD[1] = 2
		ElseIf Rssi > -130 Then I2cD[1] = 1
		Else I2cD[1] = 0 EndIf
		Gosub _DrawAntLevel			
		Delay 900
	Else
		I2cD[1]=13:I2cD[2]=0:Gosub _SetCur
		I2cD[1] = 0: Gosub _DrawAntLevel			
	EndIf
Loop
End


'' J[\ʒu
_SetCur
	'' I2cD[1]=Col,I2cD[2]=Row [0 base]
	I2cD[0] = $80 + I2cD[2] * $20  + I2cD[1]
	I2cW I2cD[31],$00,1 
Return

'' \
_DrawChar
	'' uses I2cD[0] = Char
	I2cW I2cD[31],$40, 1: Delay 1
Return


_DrawText
	k = 0
	While ^[k] > 0
		I2cD[0] = ^[k]
		I2cW I2cD[31],$40, 1: Delay 1
		k = k + 1
	Loop
Return

_DrawText1
	I2cD[0] = $80
	I2cW I2cD[31],$00,1: Delay 10
	k = 0
	While ^[k] > 0
		I2cD[0] = ^[k]
		I2cW I2cD[31],$40, 1: Delay 1
		k = k + 1
	Loop
Return

_DrawText2
	I2cD[0] = $80 + $20
	I2cW I2cD[31],$00,1: Delay 10 
	k = 0
	While ^[k] > 0
		I2cD[0] = ^[k]
		I2cW I2cD[31],$40, 1: Delay 1
		k = k + 1
	Loop
Return

_ClearOled
	I2cD[0] = $01
	I2cW I2cD[31],$00,1: Delay 10
Return

_InitOled
	'' Clear Display
	I2cD[0] = $01
	'' WriteCommand = $00
	I2cW I2cD[31],$00,1: Delay 10
	'' Return Home
	I2cD[0] = $02
	I2cW I2cD[31],$00,1: Delay 10
	'' Display ON + Cursor ON + Blink ON [8+4+2+1=16=$0F]
	'I2cD[0] = $0F
	'' Display ON + Cursor OFF + Blink OFF [8+4+0+0=12=$0C]
	I2cD[0] = $0C
	I2cW I2cD[31],$00,1: Delay 10
	'' Clear Display
	I2cD[0] = $01
	I2cW I2cD[31],$00,1: Delay 10
Return

_ContrastMax
	I2cD[0] = $2A ''RE=1
	I2cW I2cD[31],$00,1: Delay 10
	I2cD[0] = $79 ''SD=1
	I2cW I2cD[31],$00,1: Delay 10
	I2cD[0] = $81 ''RgXgZbg
	I2cW I2cD[31],$00,1: Delay 10
	I2cD[0] = $FF ''Pxl`w ''W=$7F
	I2cW I2cD[31],$00,1: Delay 10
	I2cD[0] = $78 ''SD Oɂǂ
	I2cW I2cD[31],$00,1: Delay 10
	I2cD[0] = $28 ''2C=@28=m[} 
	I2cW I2cD[31],$00,1: Delay 10
Return

_DrawAntLevel
	If I2cD[1] = 0 Then
		I2cD[0] = 0: Gosub _DrawChar
	ElseIf I2cD[1] = 1 Then
		I2cD[0] = 1: Gosub _DrawChar
	Elseif I2cD[1] >= 2 Then
		I2cD[0] = 2: Gosub _DrawChar
		If I2cD[1] = 3 Then
			I2cD[0] = 3: Gosub _DrawChar
		ElseIf I2cD[1] >= 4 Then
			I2cD[0] = 4: Gosub _DrawChar
			If I2cD[1] >= 5 Then
				I2cD[0] = 5:Gosub _DrawChar
			EndIf
		EndIf
	EndIf
Return

'' Oo^
_SetMyChars
	I2cD[0] = $40 | 0 * $08
	I2cW I2cD[31],$00, 1: Delay 1
	I2cD[0] = $1C '11100
	I2cD[1] = $08 '01000
	I2cD[2] = $08 '01000
	I2cD[3] = $00 '00000
	I2cD[4] = $00 '00000
	I2cD[5] = $00 '00000
	I2cD[6] = $00 '00000
	I2cD[7] = $00 '00000
	I2cW I2cD[31],$40, 8: Delay 1

	I2cD[0] = $40 | 1 * $08
	I2cW I2cD[31],$00, 1: Delay 1
	I2cD[0] = $1C '11100
	I2cD[1] = $08 '01000
	I2cD[2] = $08 '01000
	I2cD[3] = $00 '00000
	I2cD[4] = $00 '00000
	I2cD[5] = $0C '01100
	I2cD[6] = $0C '01100
	I2cD[7] = $00 '00000
	I2cW I2cD[31],$40, 8: Delay 1

	I2cD[0] = $40 | 2 * $08
	I2cW I2cD[31],$00, 1: Delay 1
	I2cD[0] = $1C '11100
	I2cD[1] = $08 '01000
	I2cD[2] = $08 '01000
	I2cD[3] = $00 '00000
	I2cD[4] = $03 '00011
	I2cD[5] = $1B '11011
	I2cD[6] = $1B '11011
	I2cD[7] = $00 '00000
	I2cW I2cD[31],$40, 8: Delay 1

	I2cD[0] = $40 | 3 * $08
	I2cW I2cD[31],$00, 1: Delay 1
	I2cD[0] = $00 '00000
	I2cD[1] = $00 '00000
	I2cD[2] = $00 '00000
	I2cD[3] = $18 '11000
	I2cD[4] = $18 '11000
	I2cD[5] = $18 '11000
	I2cD[6] = $18 '11000
	I2cD[7] = $00 '00000
	I2cW I2cD[31],$40, 8: Delay 1

	I2cD[0] = $40 | 4 * $08
	I2cW I2cD[31],$00, 1: Delay 1
	I2cD[0] = $00 '00000
	I2cD[1] = $00 '00000
	I2cD[2] = $03 '00011
	I2cD[3] = $1B '11011
	I2cD[4] = $1B '11011
	I2cD[5] = $1B '11011
	I2cD[6] = $1B '11011
	I2cD[7] = $00 '00000
	I2cW I2cD[31],$40, 8: Delay 1

	I2cD[0] = $40 | 5 * $08
	I2cW I2cD[31],$00, 1: Delay 1
	I2cD[0] = $00 '00000
	I2cD[1] = $18 '11000
	I2cD[2] = $18 '11000
	I2cD[3] = $18 '11000
	I2cD[4] = $18 '11000
	I2cD[5] = $18 '11000
	I2cD[6] = $18 '11000
	I2cD[7] = $00 '00000
	I2cW I2cD[31],$40, 8: Delay 1
Return
